/*Zadani:
 * Sestavte proceduru, ktera cisla vyjadrena arabskymi cislicemi v desitkove  *
 * soustave transformuje na odpovidajici cislo vyjadrene rimskymi cislicemi a *
 * opacne. Vlastni prevodni funkce napiste v asembleru.                       */

/*Autor: Martin KOT           *
 *Studijni cislo: KOT119      */

#include <stdio.h>
#include <string.h>

#define CH1 -1     /* Hodnota chyby v prevodech */
#define CH2 -2     /* Hodnota chyby pro neregulerni rimske cislo */
#define MAX 512    /* Maximalni delka retezcu */
#define MAXARAB 500000

const char rim[]={'I','V','X','L','C','D','M'};    /* Znaky rimskych cisel */
const int hodnoty[]={1,5,10,50,100,500,1000};      /* Odpovidajici hodnoty */

//Funkce napsane v asembleru
int rim_arab(char *rimske); 
int mocnina(int cislo,int exp); 
int jecislo(char *argument); 
int arab_rim(int cis,char *s);

/*int jecislo(char *argument)       // Funkce, vracejici hodnotu 1, pokud je 
{                                 // retezec prirozene cislo. Jinak vraci 0 
  int cis=1,                      // Predpoklad - retezec je cislo 
      i=0;
  while (argument[i] != '\0')    
  {
    if (argument[i] < '0' || argument[i] > '9')    //Pokud se vyskytuje jiny
      cis=0;                                     //znak, nez cislo, meni se  
    i++;                                         //navratova hodnota na 0
  }
  return cis;
}*/ // int jecislo(char *argument) 

/*int mocnina(int cislo,int exp)  // Pomocna funkce vracejici cislo^exp pro 
{                               // cela cisla a cele nezaporne exponenty 
  int i,vysl;
  if (exp==0) vysl=1;
  else 
  {
    vysl=cislo;
    for (i=1;i<exp;i++)
      vysl*=cislo;
  }
  return vysl;
} //int mocnina(int cislo,int exp) */

int hodnota(int pismeno)   //Pomocna funkce vracujici poradi hodnoty rimskeho
{                          //znaku, nebo CH1 pro ostatni znaky
  int i=0;
  while ((i<=6) && (pismeno!=rim[i])) 
    i++;
  if (i==7){        // i==7 znamena, ze znak neni v sedmiznakovem poli rim[]  
    return CH1;
  }else{
    return i;
  }
} //int hodnota(int pismeno)

void mala_velka(char *ret)   /* Funkce meni mala pismena v retezci na velka */
{                            /* Ostatni znaky jsou ponechany beze zneny */
  int i,delka=strlen(ret);
  for (i=0;i<delka;i++)
  { 
    if (*(ret+i) >= 'a' && *(ret+i) <= 'z')   /*Test, zda je znak male pismeno*/
      *(ret+i)-= 'a' - 'A';                  /*Prevedeni na velka pismena*/
  }
  *(ret+i)='\0';                            /*Na konec retezce da znak \0 */
} /*void mala_velka(char *ret)*/

void napoveda(void)                /*Procedura vypisujici napovedu k programu*/
{
puts("Tento program slouzi k prevodu rimskych a arabskych cisel obema smery.");
puts("\nSyntaxe spusteni programu je nasledujici: jmeno [prepinac] [argument]");
puts("kde 'jmeno' je nazev programu.\n");
puts("Pri spusteni bez prepinacu i argumentu se spusti interaktivni verze "
"programu.");
puts("Zde je mozno zadavat jak rimska tak arabska cisla a program je sam "
"prevede.");
puts("Ukonceni teto verze programu se provede zadanim retezce \"konec\".\n");
puts("Dalsi variantou je spusteni programu bez prepinacu s argumentem, "
"kterym je ");
puts("arabske nebo rimske cislo. Program ho prevede a skonci.\n");
puts("Pokud je prepinac \"-m\", budou pred prevodem zmenena vsechna mala "
"pismena"); 
puts("na velka. Ostatni znaky jsou ponechany bez zmeny.\n");
puts("Je-li prepinac \"-h\" zobrazi se napoveda. Pripadny argument se"
" prevede.\n");
puts("Chcete-li program pouzit jako filtr, zadejte prepinac -a pro prevod z "
"rimskych");
puts("do arabskych cisel. K opacnemu prevodu slouzi prepinac \"-r\". V obou "
"pripadech");
puts("program konci pri nacteni symbolu EOF\n");
puts("Na ostatni argumenty program nebere zretel.\n");
} /* void napoveda(void) */

/*int arab_rim(int cis,char *s)   //Fukce prevadejici arabske cislo na rimske,
{                               //ktere zapise do retezce s
  int i,c,j=0;
  
  if (cis==0) return CH1;     //Pokud je cislo 0, vraci CH1 (0 nelze prevest)

  for (;cis>=1000;cis-=1000)  // Do retezce s se ulozi znaky M odpovidajici 
  {                           // poctu tisicu cisla cis 
    s[j++]='M';
  }

  for (i=2;i>=0;i--)         // i=0 -jednotky, i=1 -desitky, i=2 -stovky 
  {
    if (cis>=(9*mocnina(10,i)))  //Pokud je cislo vetsi nez 900 (resp. 90, 9)  
    {                            
      s[j++]=rim[2*i];          //ulozi do retezce s znak C (resp. X, I)
      s[j++]=rim[2+2*i];        //a znak M (resp. C, X) 
      cis-=(9*mocnina(10,i));   //pote zmensi cislo cis o 900 (resp. 90, 9)
    }
    if (cis >= (5*mocnina(10,i))) //Pokud je cislo > 500 (resp. 50, 5)
    {
      s[j++]=rim[1+2*i];          //ulozi do retezce s znak D (resp. L, V) 
      cis-=(5*mocnina(10,i));     //a zmensi cislo cis o 500 (resp. 50, 5)  
    }
    switch(cis/mocnina(10,i))    //Spocita pocet stovek (desitek, jednotek)
    {                            //a zapise odpovidajici znaky do retezce s
      case 1: s[j++]=rim[2*i];   //Znak C (X, I)
      break;
      case 2: s[j++]=rim[2*i];   //Znaky CC (XX, II) 
        s[j++]=rim[2*i];
      break;
      case 3: s[j++]=rim[2*i];   //Znaky CCC (XXX, III) 
        s[j++]=rim[2*i];
        s[j++]=rim[2*i];
      break;
      case 4: s[j++]=rim[2*i];     //Znaky CD (XL, IX)
              s[j++]=rim[1+2*i];   
     break;
    }  // switch(cis/mocnina(10,i)) 
    cis%=mocnina(10,i);           //Zmensi cislo cis o zapsane cifry
  } //for(i=2,i<=0,i--)
  for (;j<MAX;j++)              //Doplni zbyvajici prvky pole s znakem '\0'
    s[j]='\0';
  return 0;
} //int arab_rim(int cis,char *s)*/

/*int rim_arab(char *rimske)   //Funkce prevadejici retezec rimske na arabske  
{                                                       //cislo
  int arab=0,                //Arabske cislo, ktere je vraceno touto funkci
      i=0,j,               //Pomocne promenne
      delka=strlen(rimske),  //Delka retezce rimske (delka rimskeho cisla)
      cishod[MAX],           //Pole s hodnotami znaku retezce rimske 
                             // v arabskych cislech 
      pocty[7]={0,0,0,0,0,0,0};  //pole obsahujici pocty znaku rimskych cisel

  while(i<delka)    //Cyklus priradi do pole cishod[] hodnoty znaku rimskych
  {                 //cisel
    j=hodnota(*(rimske+i)); //Do j se ulozi index znaku rim. cis. v poli rim[]
    if (j==CH1)          //Pokud funkce hodnota vratila CH1 (znak neni znakem
      return CH1;        //rimskych cisel) vrati i funkce rim_arab hodnotu CH1
    cishod[i]=hodnoty[j]; //Do pole cishod se ulozi hodnota znaku s indexem j 
    pocty[j]++;           //Pocet prislusneho znaku se zvysi o 1
    i++;
  } 
 
  if ((pocty[1]>1) || (pocty[3]>1) || (pocty[5]>1))  //Pokud je pocet znaku 
    return CH2;                        //V,L nebo D >1 vraci funkce chybu CH2

  if ((pocty[0]>3) || (pocty[2]>4) || (pocty[4]>4)) //Pokud je pocet znaku 
    return CH2;                        //I,X nebo C >3 vraci funkce chybu CH2
 
  for (j=i;j<delka;j++)   //Prvky pole cishod s indexy vetsimi nez delka retezce
    cishod[j]=0;        //rimske budou 0

  for (i=0;i<(delka-1);i++)         //Kontroluje kazdou hodnotu znaku rim. cisel
  {
    for (j=i+1;j<delka-1;j++)      //se vsemi znaky s vetsimi indexy
    {
      if (cishod[i]<cishod[j+1])  //Pokud je hodnota znaku s mensim idexem 
        return CH2;               //mensi nez hodnota znaku s o 2 vetsim 
    }                             //indexem vraci funkce rim_arab CH2
  }  
  
  for (i=0;i<delka-3;i++)              //Pokud jsou za sebou 4 stejne znaky    
    if(cishod[i]==cishod[i+1] && cishod[i+1]==cishod[i+2] 
      && cishod[i+2]==cishod[i+3] && cishod[i]!=0 && cishod[i]!=1000)
      return CH2;                   //a nejsou to 0 nebo 1000 vraci funkce CH2
  
  for (i=0;i<delka-1;i++)                  //Kontroluje retezce "VX" "LC" "DM"
    if ((cishod[i]==5 && cishod[i+1]==10) || (cishod[i]==50 && cishod[i+1]==100)
      || (cishod[i]==500 && cishod[i+1]==1000))
      return CH2;

  for (i=0;i<delka-1;i++)          //Cyklus kontroluje hodnoty znaku retezce  
  {
    if (cishod[i]<cishod[i+1])  //Pokud ma znak mensi hodnotu nez nasledujici
      cishod[i]=-cishod[i];     //bude se odecitat (proto  -cishod[i])
  }
  for (i=0;i<delka-2;i++)
    if (cishod[i]+cishod[i+1]+cishod[i+2]==cishod[i+1] && cishod[i]<cishod[i+1])
      return CH2;             //Pokud soucet hodnot 3 po sobe jdoucich znaku 
                              //je roven prostrednimu a prvni nema hodnotu 
                              //vetsi nez prostredni vraci funkce CH2
  for (i=0;i<delka;i++)         
    arab+=cishod[i];        //Do promenne arab se sectou vsechny hodnoty znaku

  return arab;       //Funkce vraci hodnatu retezce rimske v arabskych cislech
} *//*rim_arab(char *rimske)*/



int main(int argc, char *argv[])
{
  char ret[MAX],
       vstup[MAX],
       *r,
       znak;
  int i=0,j=1,             
      cislo=1,           /*Promenna oznacujici, zda retezec je cislo (1=ano)*/
      arabske,          
      sp=1,             /*Prom. oznacujici nespravny prepinac(1=spatny,0=dobry*/
      pocchyb=0;        /*Pocet chyb pri prevodu*/

  if (argc>1)          /*Pokud je pocet argumentu prikazove radky >1 */
  {
    if (argv[1][0]=='-')   /*Pokud druhy argument zacina znakem '-'*/
    {
      r=&argv[1][1];       /* r je ukazatel na druhy znak druheho argumentu*/
      if (jecislo(r)==1)       /*Pokud je od druheho znaku argumentu cislo*/
      {                        /*vypise chybove hlaseni a program konci*/
        fprintf(stderr,"Zaporna cisla nelze prevadet.\n");
        return 0;
      }
      if (strcmp(argv[1],"-h")==0)   /*Pokud je druhy argument -h*/
      {
       napoveda();                   /*vypise napovedu*/
       sp=0;                         /*zaznamena, ze prepinac byl spravny*/
        if (argc>2)              /*Pokud byl na prikazove radce dalsi argument*/
          j=2;                   /*ulozi se do j jeho index*/
        else return 0;           /*jinak program konci*/
      }
      if (strcmp(argv[1],"-r")==0)  /*Pokud je prepinac -r bude se prevadet*/
      {                                      /*do rimskych cisel*/
        while ((vstup[i]=getchar()) != EOF)   /*Nacita znaky ze stdin dokud*/
        {                                     /*neni EOF*/
          if (vstup[i]<=' ')              /*Pokud je znak bily znak*/
          {
            putchar(vstup[i]);          /*vypise se na stdout*/
            i=0;                        
            continue;              /*dalsi pruchod cyklem bez dokonceni tohoto*/
          } 
          i++;
          while ((vstup[i]=znak=getchar()) > ' ') /*Nacita znaky dokud nenacte*/
            i++;                                  /*bily znak*/
          vstup[i]='\0';            /*Na dalsi pozici pole vstup da zarazku \0*/
          cislo=jecislo(vstup);     /*Zjisti, zda retezec vstup je cislo*/
          if (cislo == 1)           /*pokud ano*/
          {
            sscanf(vstup,"%d",&arabske);    /*nacte tento retezec jako cele*/
                                            /*cisla do promenne arabske*/
	    if(arabske>MAXARAB){
             pocchyb++;                    
             printf("%s%c",vstup,znak); 
	    }
	    else {
            if (arab_rim(arabske,ret)==CH1) /*Prevede arabske cislo na rimske*/
            {                               /*ktere ulozi do retezce ret*/
              pocchyb++;                    /*Pokud pri prevodu doslo k chybe*/
              printf("%s%c",vstup,znak);    /*zvetsi pocet chyb a vypise*/
            }                               /*puvodni vstup na stdout*/
            else
              printf("%s%c",ret,znak);      /*jinak vypise prevedene cislo*/
	    }
          } /*if (cislo == 1)*/
          else                              /*Pokud vstup nebylo cislo*/
          {
            pocchyb++;                      /*zapocita ho jako chybu*/
            printf("%s%c",vstup,znak);      /*a vypise puvodni vstup*/
          }
          i=0;
        } /*while ((vstup[i]=getchar()) != EOF)*/ 

        if (pocchyb>0)          /*Pokud pri prevodu byly chyby, vypise jejich*/
                                /*pocet na stderr a program konci*/
          fprintf(stderr,"Pocet nepreveditelnych retezcu: %d\n",pocchyb);
        return 0;
      } /*if(strcmp(argv[1],"-r")==0)*/
      if (strcmp(argv[1],"-a")==0)     /*Pokud je prepinac -a, bude se*/
      {                                /*prevadet na arabske cisla*/
        while ((vstup[i]=getchar()) != EOF) /*Nacita znaky ze stdin dokud */
        {                                   /*nenacte EOF*/
          if (vstup[i]<=' ')                /*Pokud byl nacten bily znak*/
          {                                
            putchar(vstup[i]);              /*vypise se na stdout*/
            i=0;
            continue;                      
          } 
          i++;
          while ((vstup[i]=znak=getchar()) > ' ')  /*Nacita znaky dokud */
            i++;                                   /*nenacte bily znak*/
          vstup[i]='\0';              /*Na konec vstupniho retezce da zarazku*/
          i=0;
          arabske=rim_arab(vstup);    /*Prevede vstup na arabske cislo*/
          if (arabske==CH1 || arabske==CH2) /*Pokud doslo k chybe*/
          {
            pocchyb++;                      /*zvetsi jejich pocet*/
            printf("%s%c",vstup,znak);      /*a vypise puvodni vstup*/
          }
          else 
            printf("%d%c",arabske,znak);   /*Jinak vypise prevedene cislo*/
                                           /*i bily znak za nim*/
        } /*while ((vstup[i]=getchar()) != EOF)*/
 
        if (pocchyb>0)                 /*Pokud byla pri prevodu nejaka chyba*/
          fprintf(stderr,"Pocet nepreveditelnych retezcu: %d\n",pocchyb);
        return 0;                      /*vypise jejich pocet a konci*/
      } /*if(strcmp(argv[1],"-a")==0)*/

      if (strcmp(argv[1],"-m")==0)     /*Pokud je prepinac -m*/
      { 
        if (argc>2)                    /*a za nim je dalsi argument*/
        {
          j=2;                         /*ulozi se do j jeho index*/  
          mala_velka(argv[j]);     /*a male pismena v nem se prevedou na velka*/
          sp=0;                    /*Ulozi informaci, ze prepinac byl dobry*/
        }
        else                       /*Pokud za prepinacem dalsi argument neni*/
        {  
          fprintf(stderr,"Nebylo zadano cislo na prevedeni\n");       /*vypise*/
          return 0;                                  /*chybove hlaseni a konci*/
        }
      } /*if (strcmp(argv[1],"-m")==0)*/
 
      if (sp==1)                   /*Pokud prepinac je spatny*/
      {
        fprintf(stderr,"'%s'je neznamy prepinac.\n",argv[1]); /*vypise hlaseni*/
        if (argc>2)                       /*Pokud je za nim dalsi argument*/
          j=2;                            /*ulozi do j jeho index*/
        else return 0;                    /*Jinak konci*/
      }
    } /*if(argv[1][0]=='-')*/
    cislo=jecislo(argv[j]);      /*Zjisti, zda nasledujici argument je cislo*/
    if (cislo == 1)                               /*Pokud ano*/
    {
      sscanf(argv[j],"%d",&arabske);    /*Nacte ho jako cele cislo do arabske*/
      if(arabske>MAXARAB){
	fprintf(stderr,"Cislo je prilis velke.\n");      
      }
      else {
      if (arab_rim(arabske,ret)==CH1)   /*a prevede ho do retezce ret*/
        fprintf(stderr,"Rimane nulu neznali.\n");   /*Pri chybe vypise hlaseni*/
      else                            /*Jinak vypise puvodni i prevedene cislo*/
        printf("Cislo %d je v rimskych cislech: %s\n",arabske,ret);
      }
    }
    else                                      /*Pokud argument neni cislo*/
    {
      arabske=rim_arab(argv[j]);        /*Prevede rimske cislo na arabske*/  
      if (arabske==CH1)             /*Pokud doslo k chybe, vypise hlaseni*/
        fprintf(stderr,"Retezec %s nelze prevest!\n",argv[j]);
      else
        if (arabske==CH2) 
          fprintf(stderr,"Cislo %s neni regulerne zadane.\n",argv[j]);
        else                        /*Pokud ne, vypise prevedene cislo*/
          printf("Cislo %s je v arabskych cislech: %d\n",argv[j],arabske);
    }
  }  /*if(argc>1)*/
  else       /*Pokud nejsou na prikazove radce argumenty (mimo nazvu)*/
  {                                        /*Vypise strucnou napovedu*/

    puts("\nTento program slouzi k prevodu mezi arabskymi a rimskymi cisly"
    " obema smery.");
    puts("Ukonceni se provede zadanim retezce \"konec\".");
    puts("Pro vice informaci spuste program prikazem \"jmeno -h\", kde jmeno "
    "je nazev");
    puts("programu.\n");

    for (;;)      /*Nekonecny cyklus interaktivni verze programu*/     
    {
      printf("\nZadej cislo k prevodu: ");     /*Vypise vyzvu*/
      scanf("%s",vstup);                       /*Nacte vstupni retezec*/
      if (strcmp(vstup,"konec")==0)      /*Pokud je na vstupu retezec "konec"*/
        return 0;                        /*program konci*/
      cislo=jecislo(vstup);              /*Zjisti, zda je na vstupu cislo*/
      if (cislo == 1)                    /*Pokud ano*/
      {
        sscanf(vstup,"%d",&arabske);     /*nacte ho z retezce jako cele cislo*/
	if(arabske>MAXARAB){
  	  fprintf(stderr,"Cislo je prilis velke.\n");
	}
	else {
        if (arab_rim(arabske,ret)==CH1)  /*a prevede. Pokud dojde pri prevodu*/
          fprintf(stderr,"Rimane nulu neznali.\n");  /*k chybe vypise hlaseni*/
        else                             /*Jinak vypise prevedene cislo*/
          printf("Cislo %d je v rimskych cislech: %s\n",arabske,ret);
	}
      }
      else                               /*Pokud vstup nebylo cislo*/
      {
        arabske=rim_arab(vstup);         /*prevede retezec na arabske cislo*/
        if (arabske==CH1)            /*Pokud pri prevodu dojde k chybe vypise*/
          fprintf(stderr,"Retezec %s nelze prevest!\n",vstup);      /*hlaseni*/
        else
          if (arabske==CH2) 
            fprintf(stderr,"Cislo %s neni regulerne zadane.\n",vstup);
          else                              /*Jinak vypise prevedene cislo*/
            printf("Cislo %s je v arabskych cislech: %d\n",vstup,arabske);
      }
    } /* for(;;) */
  } /*if(argc>1) else*/
  return 0;                                    /*konec programu*/
} /*int main(int argc,char *argv[])*/

